##
# Density of a Student's $t$ copula in terms of Kendall's tau.
#

dTC <- function(x, y, tau, nu) {

	rho <- sin((tau * pi) / 2)

	x <- qt(x, nu)
	y <- qt(y, nu)
	1 / (2 * pi * sqrt(1 - rho^2)) *
		(1 + (x^2 + y^2 - 2 * rho * x * y) / (nu * (1 - rho^2)))^(-(nu + 2) / 2) * dt(x, nu)^-1 * dt(y, nu)^-1
}

logdTC <- function(x, y, tau, nu) {

	rho <- sin((tau * pi) / 2)

	x <- qt(x, nu)
	y <- qt(y, nu)

	-log(2 * pi) - 0.5 * log(1 - rho^2) -
		(nu + 2) / 2 * log(1 + (x^2 + y^2 - 2 * rho * x * y) / (nu * (1 - rho^2))) - dt(x, nu, log = T) - dt(y, nu, log = T)
}
