
library(copula)

source("cTC.R")

# We generate a synthetic dataset of size 2000

n <- 1001

set.seed(1)

# We generate the data

X <- matrix(0, n, 2)
tau <- rep(0, n)
nu <- rep(0, n)
time <- 1 : n
for (i in time) {
	nu[ i ] <- 1 + 2 * (1 + cos(i * 2 * pi / 500))
	tau[ i ] <- 0.3 + 0.2 * (1 + cos(i * 2 * pi / 250))
	X[ i, ] <- rCopula(1, tCopula(sin((tau[ i ] * pi) / 2), 2, df = nu[ i ]))
	print(i)
}

# We adjust a conditional student t copula to the first 1000 observations

Z <- matrix(time, n, 1)

Xtrain <- X[ 1 : (nrow(X) - 1), ]
Xtest <- matrix(X[ nrow(X), ], 1, 2)

Ztrain <- matrix(Z[ 1 : (nrow(Z) - 1), ], nrow(Z) - 1, ncol(Z))
Ztest <- matrix(Z[ nrow(Z), ], 1, ncol(Z))

ret <- fitCTC(Xtrain, Ztrain, m = 100)

# We evaluate the test ll of the conditional copula

retTest <- evaluateLLCTC(ret, Xtest[ , 1 ], Xtest[ , 2 ], Ztest)

print(retTest)
